Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/Client.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/Client.cs	(revision 4953)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/Client.cs	(revision 5335)
@@ -1,22 +1,20 @@
 ﻿using System.Runtime.Serialization;
 
-namespace HeuristicLab.Services.Authentication.DataTransfer
-{
-    [DataContract]
-    public class Client : HeuristicLab.Services.Authentication.DataTransfer.Resource
-    {
-        [DataMember]
-        public string ProcessorType { get; set; }
-        [DataMember]
-        public string NumberOfProcessors { get; set; }
-        [DataMember]
-        public string NumberOfThreads { get; set; }
-        [DataMember]
-        public string IPAdress { get; set; }
-        [DataMember]
-        public string MemorySize { get; set; }
-        [DataMember]
-        public string OperatingSystem { get; set; }
+namespace HeuristicLab.Services.Authentication.DataTransfer {
+  [DataContract]
+  public class Client : HeuristicLab.Services.Authentication.DataTransfer.Resource {
+    [DataMember]
+    public string ProcessorType { get; set; }
+    [DataMember]
+    public string NumberOfProcessors { get; set; }
+    [DataMember]
+    public string NumberOfThreads { get; set; }
+    [DataMember]
+    public string IPAdress { get; set; }
+    [DataMember]
+    public string MemorySize { get; set; }
+    [DataMember]
+    public string OperatingSystem { get; set; }
 
-    }
+  }
 }
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/Resource.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/Resource.cs	(revision 4953)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/Resource.cs	(revision 5335)
@@ -1,20 +1,21 @@
 ﻿using System.Runtime.Serialization;
+using System.Collections.Generic;
 
-namespace HeuristicLab.Services.Authentication.DataTransfer
-{
-    [DataContract]
-    public abstract class Resource
-    {
-        [DataMember]
-        public System.Guid Id { get; set; }
-        [DataMember]
-        public string Name { get; set; }
-        [DataMember]
-        public string Description { get; set; }
-        [DataMember]
-        public string ResourceType { get; set; }
-        [DataMember]
-        public System.Guid ResourceGroup { get; set; }
-    }
+namespace HeuristicLab.Services.Authentication.DataTransfer {
+  [DataContract]
+  public abstract class Resource {
+    public enum ResourceTypes { Client, ResourceGroup };
+
+    [DataMember]
+    public System.Guid Id { get; set; }
+    [DataMember]
+    public string Name { get; set; }
+    [DataMember]
+    public string Description { get; set; }
+    [DataMember]
+    public ResourceTypes ResourceType { get; set; }
+    [DataMember]
+    public IEnumerable<System.Guid> ResourceGroup { get; set; }
+  }
 }
 
Index: branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/ResourceGroup.cs
===================================================================
--- branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/ResourceGroup.cs	(revision 4953)
+++ branches/ClientManagement/HeuristicLab.Services.Authentication/HeuristicLab.Services.Authentication.DataTransfer/ResourceGroup.cs	(revision 5335)
@@ -1,10 +1,8 @@
 ﻿using System.Runtime.Serialization;
 
-namespace HeuristicLab.Services.Authentication.DataTransfer
-{
-    [DataContract]
-    public class ResourceGroup : Resource
-    {
-    }
+namespace HeuristicLab.Services.Authentication.DataTransfer {
+  [DataContract]
+  public class ResourceGroup : Resource {
+  }
 }
 