Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5337)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5338)
@@ -94,4 +94,6 @@
   <ItemGroup>
     <Compile Include="AdministratorMenuItem.cs" />
+    <Compile Include="SingleObjectiveOKBProblem.cs" />
+    <Compile Include="OKBProblem.cs" />
     <Compile Include="QueryMenuItem.cs" />
     <Compile Include="OKBClient.cs" />
@@ -182,4 +184,10 @@
       <DependentUpon>AlgorithmParameterView.cs</DependentUpon>
     </Compile>
+    <Compile Include="Views\OKBProblemView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\OKBProblemView.Designer.cs">
+      <DependentUpon>OKBProblemView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\SetComparisonStringAvailableValuesFilterView.cs">
       <SubType>UserControl</SubType>
@@ -382,4 +390,9 @@
     <None Include="HeuristicLab.snk" />
     <None Include="HeuristicLabClientsOKBPlugin.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Views\OKBProblemView.resx">
+      <DependentUpon>OKBProblemView.cs</DependentUpon>
+    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBExperiment.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBExperiment.cs	(revision 5337)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBExperiment.cs	(revision 5338)
@@ -31,5 +31,5 @@
 namespace HeuristicLab.Clients.OKB {
   [Item("OKB Experiment", "...")]
-  [Creatable("OKB")]
+  [Creatable("Optimization Knowledge Base (OKB)")]
   [StorableClass]
   public sealed class OKBExperiment : NamedItem, IOptimizer, IStorableContent {
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBProblem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBProblem.cs	(revision 5338)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBProblem.cs	(revision 5338)
@@ -0,0 +1,257 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.IO;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Persistence.Default.Xml;
+
+namespace HeuristicLab.Clients.OKB {
+  [Item("OKB Problem", "Represents a problem which is stored in the OKB.")]
+  [StorableClass]
+  public class OKBProblem : Item, IProblem, IStorableContent {
+    public string Filename { get; set; }
+
+    public override Image ItemImage {
+      get { return Problem == null ? HeuristicLab.Common.Resources.VSImageLibrary.Type : Problem.ItemImage; }
+    }
+
+    public string Name {
+      get { return Problem == null ? ItemName : Problem.Name; }
+      set { throw new NotSupportedException("Name cannot be changed."); }
+    }
+    public string Description {
+      get { return Problem == null ? ItemDescription : Problem.Description; }
+      set { throw new NotSupportedException("Description cannot be changed."); }
+    }
+    public bool CanChangeName {
+      get { return false; }
+    }
+    public bool CanChangeDescription {
+      get { return false; }
+    }
+
+    public IKeyedItemCollection<string, IParameter> Parameters {
+      get { return Problem == null ? null : Problem.Parameters; }
+    }
+
+    public virtual Type ProblemType {
+      get { return typeof(IProblem); }
+    }
+    private long problemId;
+    public long ProblemId {
+      get { return problemId; }
+    }
+    private IProblem problem;
+    public IProblem Problem {
+      get { return problem; }
+      private set {
+        if (value == null) throw new ArgumentNullException("Problem");
+        if (value != problem) {
+          CancelEventArgs<string> e = new CancelEventArgs<string>(value.Name);
+          OnNameChanging(e);
+          if (!e.Cancel) {
+            DeregisterProblemEvents();
+            problem = value;
+            RegisterProblemEvents();
+
+            OnToStringChanged();
+            OnItemImageChanged();
+            OnNameChanged();
+            OnDescriptionChanged();
+            OnProblemChanged();
+            OnSolutionCreatorChanged();
+            OnEvaluatorChanged();
+            OnOperatorsChanged();
+            OnReset();
+          }
+        }
+      }
+    }
+
+    public IParameter SolutionCreatorParameter {
+      get { return Problem == null ? null : Problem.SolutionCreatorParameter; }
+    }
+    public ISolutionCreator SolutionCreator {
+      get { return Problem == null ? null : Problem.SolutionCreator; }
+    }
+    public IParameter EvaluatorParameter {
+      get { return Problem == null ? null : Problem.EvaluatorParameter; }
+    }
+    public IEvaluator Evaluator {
+      get { return Problem == null ? null : Problem.Evaluator; }
+    }
+    public IEnumerable<IOperator> Operators {
+      get { return Problem == null ? Enumerable.Empty<IOperator>() : Problem.Operators; }
+    }
+
+    #region Persistence Properties
+    [Storable(Name = "ProblemId")]
+    private long StorableProblemId {
+      get { return problemId; }
+      set { problemId = value; }
+    }
+    [Storable(Name = "Problem")]
+    private IProblem StorableProblem {
+      get { return Problem; }
+      set { Problem = value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected OKBProblem(bool deserializing) : base(deserializing) { }
+    protected OKBProblem(OKBProblem original, Cloner cloner)
+      : base(original, cloner) {
+      problemId = original.problemId;
+      problem = cloner.Clone(original.problem);
+    }
+    protected OKBProblem()
+      : base() {
+      problemId = -1;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OKBProblem(this, cloner);
+    }
+
+    public void Load(long problemId) {
+      if (this.problemId != problemId) {
+        IProblem problem;
+        ProblemData problemData = OKBClient.Instance.GetProblemData(problemId);
+        using (MemoryStream stream = new MemoryStream(problemData.Data)) {
+          problem = XmlParser.Deserialize<IProblem>(stream);
+        }
+        if (ProblemType.IsAssignableFrom(problem.GetType())) {
+          this.problemId = problemId;
+          Problem = problem;
+        }
+      }
+    }
+
+    public void CollectParameterValues(IDictionary<string, IItem> values) {
+      if (Problem != null) Problem.CollectParameterValues(values);
+    }
+
+    #region Events
+    public event EventHandler<CancelEventArgs<string>> NameChanging;
+    protected virtual void OnNameChanging(CancelEventArgs<string> e) {
+      var handler = NameChanging;
+      if (handler != null) handler(this, e);
+    }
+    public event EventHandler NameChanged;
+    protected virtual void OnNameChanged() {
+      var handler = NameChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler DescriptionChanged;
+    protected virtual void OnDescriptionChanged() {
+      var handler = DescriptionChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ProblemChanged;
+    protected virtual void OnProblemChanged() {
+      EventHandler handler = ProblemChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler SolutionCreatorChanged;
+    protected virtual void OnSolutionCreatorChanged() {
+      var handler = SolutionCreatorChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler EvaluatorChanged;
+    protected virtual void OnEvaluatorChanged() {
+      var handler = EvaluatorChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler OperatorsChanged;
+    protected virtual void OnOperatorsChanged() {
+      var handler = OperatorsChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler Reset;
+    protected virtual void OnReset() {
+      var handler = Reset;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    protected virtual void RegisterProblemEvents() {
+      if (Problem != null) {
+        Problem.ToStringChanged += new EventHandler(Problem_ToStringChanged);
+        Problem.ItemImageChanged += new EventHandler(Problem_ItemImageChanged);
+        Problem.NameChanging += new EventHandler<CancelEventArgs<string>>(Problem_NameChanging);
+        Problem.NameChanged += new EventHandler(Problem_NameChanged);
+        Problem.DescriptionChanged += new EventHandler(Problem_DescriptionChanged);
+        Problem.SolutionCreatorChanged += new EventHandler(Problem_SolutionCreatorChanged);
+        Problem.EvaluatorChanged += new EventHandler(Problem_EvaluatorChanged);
+        Problem.OperatorsChanged += new EventHandler(Problem_OperatorsChanged);
+        Problem.Reset += new EventHandler(Problem_Reset);
+      }
+    }
+    protected virtual void DeregisterProblemEvents() {
+      if (Problem != null) {
+        Problem.ToStringChanged -= new EventHandler(Problem_ToStringChanged);
+        Problem.ItemImageChanged -= new EventHandler(Problem_ItemImageChanged);
+        Problem.NameChanging -= new EventHandler<CancelEventArgs<string>>(Problem_NameChanging);
+        Problem.NameChanged -= new EventHandler(Problem_NameChanged);
+        Problem.DescriptionChanged -= new EventHandler(Problem_DescriptionChanged);
+        Problem.SolutionCreatorChanged -= new EventHandler(Problem_SolutionCreatorChanged);
+        Problem.EvaluatorChanged -= new EventHandler(Problem_EvaluatorChanged);
+        Problem.OperatorsChanged -= new EventHandler(Problem_OperatorsChanged);
+        Problem.Reset -= new EventHandler(Problem_Reset);
+      }
+    }
+
+    private void Problem_ToStringChanged(object sender, EventArgs e) {
+      OnToStringChanged();
+    }
+    private void Problem_ItemImageChanged(object sender, EventArgs e) {
+      OnItemImageChanged();
+    }
+    private void Problem_NameChanging(object sender, CancelEventArgs<string> e) {
+      OnNameChanging(e);
+    }
+    private void Problem_NameChanged(object sender, EventArgs e) {
+      OnNameChanged();
+    }
+    private void Problem_DescriptionChanged(object sender, EventArgs e) {
+      OnDescriptionChanged();
+    }
+    private void Problem_SolutionCreatorChanged(object sender, EventArgs e) {
+      OnSolutionCreatorChanged();
+    }
+    private void Problem_EvaluatorChanged(object sender, EventArgs e) {
+      OnEvaluatorChanged();
+    }
+    private void Problem_OperatorsChanged(object sender, EventArgs e) {
+      OnOperatorsChanged();
+    }
+    private void Problem_Reset(object sender, EventArgs e) {
+      OnReset();
+    }
+    #endregion
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/SingleObjectiveOKBProblem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/SingleObjectiveOKBProblem.cs	(revision 5338)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/SingleObjectiveOKBProblem.cs	(revision 5338)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Clients.OKB {
+  [Item("Single-Objective OKB Problem", "Represents a single-objective problem which is stored in the OKB.")]
+  [Creatable("Optimization Knowledge Base (OKB)")]
+  [StorableClass]
+  public sealed class SingleObjectiveOKBProblem : OKBProblem, ISingleObjectiveProblem {
+    public override Type ProblemType {
+      get { return typeof(ISingleObjectiveProblem); }
+    }
+    public new ISingleObjectiveProblem Problem {
+      get { return base.Problem as ISingleObjectiveProblem; }
+    }
+    public IParameter BestKnownQualityParameter {
+      get { return Problem == null ? null : Problem.BestKnownQualityParameter; }
+    }
+    public new ISingleObjectiveEvaluator Evaluator {
+      get { return Problem == null ? null : Problem.Evaluator; }
+    }
+    public IParameter MaximizationParameter {
+      get { return Problem == null ? null : Problem.MaximizationParameter; }
+    }
+
+    [StorableConstructor]
+    private SingleObjectiveOKBProblem(bool deserializing) : base(deserializing) { }
+    private SingleObjectiveOKBProblem(SingleObjectiveOKBProblem original, Cloner cloner) : base(original, cloner) { }
+    public SingleObjectiveOKBProblem() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SingleObjectiveOKBProblem(this, cloner);
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Views/OKBProblemView.Designer.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Views/OKBProblemView.Designer.cs	(revision 5338)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Views/OKBProblemView.Designer.cs	(revision 5338)
@@ -0,0 +1,130 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Clients.OKB {
+  partial class OKBProblemView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      this.problemLabel = new System.Windows.Forms.Label();
+      this.problemComboBox = new System.Windows.Forms.ComboBox();
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.SuspendLayout();
+      // 
+      // problemLabel
+      // 
+      this.problemLabel.AutoSize = true;
+      this.problemLabel.Location = new System.Drawing.Point(3, 5);
+      this.problemLabel.Name = "problemLabel";
+      this.problemLabel.Size = new System.Drawing.Size(48, 13);
+      this.problemLabel.TabIndex = 7;
+      this.problemLabel.Text = "&Problem:";
+      // 
+      // problemComboBox
+      // 
+      this.problemComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.problemComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.problemComboBox.FormattingEnabled = true;
+      this.problemComboBox.Location = new System.Drawing.Point(57, 1);
+      this.problemComboBox.Name = "problemComboBox";
+      this.problemComboBox.Size = new System.Drawing.Size(551, 21);
+      this.problemComboBox.TabIndex = 8;
+      this.problemComboBox.SelectedValueChanged += new System.EventHandler(this.problemComboBox_SelectedValueChanged);
+      // 
+      // refreshButton
+      // 
+      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.refreshButton.Location = new System.Drawing.Point(614, 0);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(24, 24);
+      this.refreshButton.TabIndex = 4;
+      this.toolTip.SetToolTip(this.refreshButton, "Refresh Problems");
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      // 
+      // viewHost
+      // 
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.viewHost.Caption = "View";
+      this.viewHost.Content = null;
+      this.viewHost.Enabled = false;
+      this.viewHost.Location = new System.Drawing.Point(0, 30);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(638, 422);
+      this.viewHost.TabIndex = 9;
+      this.viewHost.ViewsLabelVisible = true;
+      this.viewHost.ViewType = null;
+      // 
+      // OKBProblemView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.viewHost);
+      this.Controls.Add(this.problemComboBox);
+      this.Controls.Add(this.problemLabel);
+      this.Controls.Add(this.refreshButton);
+      this.Name = "OKBProblemView";
+      this.Size = new System.Drawing.Size(638, 452);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label problemLabel;
+    private System.Windows.Forms.ComboBox problemComboBox;
+    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.ToolTip toolTip;
+    private MainForm.WindowsForms.ViewHost viewHost;
+
+
+
+
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Views/OKBProblemView.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Views/OKBProblemView.cs	(revision 5338)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Views/OKBProblemView.cs	(revision 5338)
@@ -0,0 +1,128 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Clients.OKB {
+  [View("OKBProblem View")]
+  [Content(typeof(OKBProblem), true)]
+  public sealed partial class OKBProblemView : ItemView {
+    public new OKBProblem Content {
+      get { return (OKBProblem)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public OKBProblemView() {
+      InitializeComponent();
+    }
+
+    protected override void OnInitialized(System.EventArgs e) {
+      base.OnInitialized(e);
+      OKBClient.Instance.Refreshing += new EventHandler(OKBClient_Refreshing);
+      OKBClient.Instance.Refreshed += new EventHandler(OKBClient_Refreshed);
+      PopulateComboBox();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.ProblemChanged -= new EventHandler(Content_ProblemChanged);
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ProblemChanged += new EventHandler(Content_ProblemChanged);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        problemComboBox.SelectedIndex = -1;
+        viewHost.Content = null;
+      } else {
+        problemComboBox.SelectedItem = OKBClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
+        viewHost.Content = Content.Problem;
+      }
+    }
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      problemComboBox.Enabled = (Content != null) && !ReadOnly && !Locked && (problemComboBox.Items.Count > 0);
+      refreshButton.Enabled = (Content != null) && !ReadOnly && !Locked;
+    }
+
+    private void PopulateComboBox() {
+      problemComboBox.DataSource = null;
+      Platform platform = OKBClient.Instance.Platforms.FirstOrDefault(x => x.Name == "HeuristicLab 3.3");
+      if (platform != null) {
+        problemComboBox.DataSource = OKBClient.Instance.Problems.Where(x => x.PlatformId == platform.Id).ToList();
+        problemComboBox.DisplayMember = "Name";
+      }
+    }
+
+    protected override void OnClosed(FormClosedEventArgs e) {
+      OKBClient.Instance.Refreshing -= new EventHandler(OKBClient_Refreshing);
+      OKBClient.Instance.Refreshed -= new EventHandler(OKBClient_Refreshed);
+      base.OnClosed(e);
+    }
+
+    private void OKBClient_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(OKBClient_Refreshing), sender, e);
+      } else {
+        Cursor = Cursors.AppStarting;
+        problemComboBox.Enabled = refreshButton.Enabled = viewHost.Enabled = false;
+      }
+    }
+    private void OKBClient_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(OKBClient_Refreshed), sender, e);
+      } else {
+        PopulateComboBox();
+        SetEnabledStateOfControls();
+        Cursor = Cursors.Default;
+      }
+    }
+
+    #region Content Events
+    private void Content_ProblemChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_ProblemChanged), sender, e);
+      else {
+        problemComboBox.SelectedItem = OKBClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
+        viewHost.Content = Content.Problem;
+      }
+    }
+    #endregion
+
+    #region Control Events
+    private void refreshButton_Click(object sender, System.EventArgs e) {
+      OKBClient.Instance.Refresh();
+    }
+    private void problemComboBox_SelectedValueChanged(object sender, System.EventArgs e) {
+      Problem problem = problemComboBox.SelectedValue as Problem;
+      if ((problem != null) && (Content != null)) Content.Load(problem.Id);
+    }
+    #endregion
+  }
+}