Index: branches/UserManagement/HeuristicLab.Services.Authentication.DataAccess/UserManagement.dbml
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.DataAccess/UserManagement.dbml	(revision 5257)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.DataAccess/UserManagement.dbml	(revision 5350)
@@ -72,14 +72,11 @@
     </Type>
   </Table>
-  <Function Name="dbo.aspnet_Membership_ResetPassword" Method="aspnet_Membership_ResetPassword">
+  <Function Name="dbo.aspnet_Membership_SetPassword" Method="aspnet_Membership_SetPassword">
     <Parameter Name="ApplicationName" Parameter="applicationName" Type="System.String" DbType="NVarChar(256)" />
     <Parameter Name="UserName" Parameter="userName" Type="System.String" DbType="NVarChar(256)" />
     <Parameter Name="NewPassword" Parameter="newPassword" Type="System.String" DbType="NVarChar(128)" />
-    <Parameter Name="MaxInvalidPasswordAttempts" Parameter="maxInvalidPasswordAttempts" Type="System.Int32" DbType="Int" />
-    <Parameter Name="PasswordAttemptWindow" Parameter="passwordAttemptWindow" Type="System.Int32" DbType="Int" />
     <Parameter Name="PasswordSalt" Parameter="passwordSalt" Type="System.String" DbType="NVarChar(128)" />
     <Parameter Name="CurrentTimeUtc" Parameter="currentTimeUtc" Type="System.DateTime" DbType="DateTime" />
     <Parameter Name="PasswordFormat" Parameter="passwordFormat" Type="System.Int32" DbType="Int" />
-    <Parameter Name="PasswordAnswer" Parameter="passwordAnswer" Type="System.String" DbType="NVarChar(128)" />
     <Return Type="System.Int32" />
   </Function>
Index: branches/UserManagement/HeuristicLab.Services.Authentication.DataAccess/UserManagement.designer.cs
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.DataAccess/UserManagement.designer.cs	(revision 5257)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.DataAccess/UserManagement.designer.cs	(revision 5350)
@@ -118,8 +118,8 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.aspnet_Membership_ResetPassword")]
-		public int aspnet_Membership_ResetPassword([global::System.Data.Linq.Mapping.ParameterAttribute(Name="ApplicationName", DbType="NVarChar(256)")] string applicationName, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="UserName", DbType="NVarChar(256)")] string userName, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="NewPassword", DbType="NVarChar(128)")] string newPassword, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="MaxInvalidPasswordAttempts", DbType="Int")] System.Nullable<int> maxInvalidPasswordAttempts, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="PasswordAttemptWindow", DbType="Int")] System.Nullable<int> passwordAttemptWindow, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="PasswordSalt", DbType="NVarChar(128)")] string passwordSalt, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="CurrentTimeUtc", DbType="DateTime")] System.Nullable<System.DateTime> currentTimeUtc, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="PasswordFormat", DbType="Int")] System.Nullable<int> passwordFormat, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="PasswordAnswer", DbType="NVarChar(128)")] string passwordAnswer)
-		{
-			IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())), applicationName, userName, newPassword, maxInvalidPasswordAttempts, passwordAttemptWindow, passwordSalt, currentTimeUtc, passwordFormat, passwordAnswer);
+		[global::System.Data.Linq.Mapping.FunctionAttribute(Name="dbo.aspnet_Membership_SetPassword")]
+		public int aspnet_Membership_SetPassword([global::System.Data.Linq.Mapping.ParameterAttribute(Name="ApplicationName", DbType="NVarChar(256)")] string applicationName, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="UserName", DbType="NVarChar(256)")] string userName, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="NewPassword", DbType="NVarChar(128)")] string newPassword, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="PasswordSalt", DbType="NVarChar(128)")] string passwordSalt, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="CurrentTimeUtc", DbType="DateTime")] System.Nullable<System.DateTime> currentTimeUtc, [global::System.Data.Linq.Mapping.ParameterAttribute(Name="PasswordFormat", DbType="Int")] System.Nullable<int> passwordFormat)
+		{
+			IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())), applicationName, userName, newPassword, passwordSalt, currentTimeUtc, passwordFormat);
 			return ((int)(result.ReturnValue));
 		}